// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "RasendeRoboter.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_UNFLOAT, OnUnfloat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	// ZU ERLEDIGEN: Hier Code zur Member-Initialisierung einfgen
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	DWORD dockStyle = CBRS_TOP| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC;
	if (!m_wndJewelBar.CreateEx(this, TBSTYLE_FLAT|TBSTYLE_WRAPABLE, WS_CHILD | WS_VISIBLE | 
		dockStyle) ||
		!m_wndJewelBar.LoadToolBar(IDR_JEWELS))
	{
		TRACE0("Jewel-Bar konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	// ZU ERLEDIGEN: Lschen Sie diese drei Zeilen, wenn Sie nicht wollen, dass die Symbolleiste
	//  andockbar ist.
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndJewelBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);

	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndJewelBar);

	m_nRows=0;
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler


/*	Lets float one of our toolbars
	but make sure that is has the
	desired row count. if the count
	is too small to be set, then
	return the row count used.

	Parameters: 
		pToolbar	Pointer to the MFC tool bar 
					object to be manipulated

		nRows		Requested number of rows

		bLarger		Tells whether to use more rows
					or fewer rows if the toolbar 
					cannot be resized to the 
					requested number of rows.
					(for details see CToolBarCtrl::SetRows
					 in the MSDN documentation)

		pClient		Pointer to a CPoint object 
					for the position int client 
					coordinates for the 
					toolbar to appear floated.
					If this Parameter is NULL, 
					the default upper left corner
					of "this" window will be used

	Returns:		the value of the function 
					CToolBarCtrl->GetRows
					after the resizing has occured.
					A simple experiment shows,
					that this is NOT the real number
					of rows displayed :( 
*/
int CMainFrame::FloatToolbarSetRows(CToolBar *pToolbar, int nRows, BOOL bLarger, CPoint *pClientPos)
{
	// default upper left corner
	// of the floating toolbar
	// is upper left corner of main wnd
	CPoint newPos(0,0); 

	// if other pos specified, use it
	if (pClientPos)
		newPos = *pClientPos;

	// functions use screen coords
	ClientToScreen(&newPos);

	// first, make sure our toolbar is floating
	if (!pToolbar->IsFloating())
		FloatControlBar(pToolbar, CPoint(0,0));

	// now set the desired row count
	// may result in more rows than specified
	// see the MSDN docs: CToolBarCtrl::SetRows
	//
	// this function also calculates the new
	// toolbar window size
	//
	// unfortunately this function only arranges
	// the toolbar buttons, but will not update
	// the size of the tool bar window ...
	CRect rcNew;
	pToolbar->GetToolBarCtrl().SetRows(nRows, bLarger, &rcNew);

	// we need to reset the horizontal extend of the toolbar
	// before it "knows" its width. It will not diplay this
	// width before the window is touched by us (or by the mouse)
	pToolbar->CalcDynamicLayout(rcNew.Width(), LM_HORZ | LM_COMMIT);
	
	// now move the window to the desired position
	FloatControlBar(pToolbar, newPos, CBRS_ALIGN_TOP | CBRS_SIZE_DYNAMIC);
	
	return pToolbar->GetToolBarCtrl().GetRows();
}

void CMainFrame::OnUnfloat() 
{
	TRACE("FloatToolbarSetRows(..%i..) = %i\n", ++m_nRows, 
		FloatToolbarSetRows(&m_wndJewelBar, m_nRows, TRUE, &CPoint(50,50)));
//
//	CRect rcNew;
//	m_wndJewelBar.GetToolBarCtrl().SetRows(5, TRUE, &rcNew);

}
